set mprint=no.
define RelRisk_pv (outcome = !charend('/')/
                  antecedent = !charend('/')/
                  infile = !charend('/')/
                  grp = !default(NOGRP) !charend('/')/
                  wgt = !default(W_FSTUWT) !charend('/')/
                  rwgt = !default(W_FSTR) !charend('/')/
                  cons = !default(0.05) !charend('/')/
                  nrep = !default(80) !charend('/')).
                
preserve.
SET Olang=English OVars names ONumbers values TVars names TNumbers values.
omsend.
oms /select headings tables texts/destination viewer=no /tag="crap".

/* nGrp is the number of group variables */
!let !nGrp=!null.
!do !g !in (!grp)
!let !nGrp=!concat(!nGrp,!blanks(1))
!doend.
!let !nGrp=!length(!nGrp).
!if (!upcase(!grp)=NOGRP) !then !let !ngrp=0 !ifend.
title Number of group variables = !ngrp.

get file !quote(!infile)
   /keep !if (!ngrp=0) !then !else !grp !ifend !outcome !antecedent !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) .
!if (!ngrp=0) !then compute !grp=1 !ifend.

!let !p=!null.
!do !o !in (!outcome).
!let !p=!concat(!p,!blanks(1)).
select if (not missing(!o)).
rename var (!o=!concat('OUT',!length(!p))).
!doend.

!let !p=!null.
!do !a !in (!antecedent).
!let !p=!concat(!p,!blanks(1)).
select if (not missing(!a)).
rename var (!a=!concat('ANT',!length(!p))).
!doend.

!do !j=1 !to 5.
sort cases by !grp !concat('ANT',!j) !concat('OUT',!j).
save outfile=!quote(!concat('c:\temp\a',!j,'.sav'))
   /keep !grp !concat('ANT',!j) !concat('OUT',!j) !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep).
!doend.


*** COMPUTE RELATIVE RISK ***.

!do !j=1 !to 5.
dataset close all.
get file=!quote(!concat('c:\temp\a',!j,'.sav')).
weight by !wgt.
aggregate outfile=* /PRESORTED /break=!GRP !concat('ANT',!j) !concat('OUT',!j)/n=N.
casestovars /id=!grp /index=!concat('ANT',!j) !concat('OUT',!j).
compute !concat('STAT.',!j)=(N.1.1/(N.1.0+N.1.1))/(N.0.1/(N.0.0+N.0.1)).
save outfile=!quote(!concat('c:\temp\',!wgt,!j,'.sav')) /keep=!grp !concat('STAT.',!j).
!doend.

match files !do !j=1 !to 5/file=!quote(!concat('c:\temp\',!wgt,!j,'.sav')) !doend /by !grp.
save outfile=!quote(!concat('c:\temp\',!wgt,'.sav')).


*** REPLICATION ***.

!do !i=1 !to !nrep.
!do !j=1 !to 5.
dataset close all.
get file=!quote(!concat('c:\temp\a',!j,'.sav')).
weight by !concat(!rwgt,!i).
aggregate outfile=* /PRESORTED /break=!GRP !concat('ANT',!j) !concat('OUT',!j)/n=N.
casestovars /id=!grp /index=!concat('ANT',!j) !concat('OUT',!j).
compute !concat('STATR.',!j)=(N.1.1/(N.1.0+N.1.1))/(N.0.1/(N.0.0+N.0.1)).
save outfile=!quote(!concat('c:\temp\',!rwgt,!i,!j,'.sav')) /keep=!grp !concat('STATR.',!j).
!doend.
match files !do !j=1 !to 5/file=!quote(!concat('c:\temp\',!rwgt,!i,!j,'.sav')) !doend /by !grp.
save outfile=!quote(!concat('c:\temp\',!rwgt,!i,'.sav')).
!doend.


* Combine replicate files.

!let !nper=50.
!if ( !length(!substr(!blanks(!nrep),!length(!concat(!blanks(!nper ),!blanks(1)))))=0 ) !then
	add files file= !quote(!concat('C:\temp\',!rwgt,'1.sav')) !do !e=2 !to !nrep /file=!quote(!concat('C:\temp\',!rwgt,!e,'.sav')) !doend .
!else
	!let !modls=!nrep.
	!let !intgr=0.
	!Do !iter=!nrep !to !nper !by -!nper
		add files file= !quote(!concat('C:\temp\',!rwgt,!iter,'.sav')) !do !e=!length(!substr(!blanks(!iter),2)) !to !length(!substr(!blanks(!iter),!length(!blanks(!nper)))) !by -1 /file=!quote(!concat('C:\temp\',!rwgt,!e,'.sav')) !doend .
		!let !modls=!length(!substr(!blanks(!modls),!length(!concat(!blanks(1),!blanks(!nper))))).
		!let !intgr=!length(!Concat(!blanks(!intgr), !blanks(1))).
		save outfile=!quote(!concat('c:\temp\',!rwgt,'_temp_',!intgr,'.sav')).
	!doend
	!if (!modls>0) !then
		!if (!modls>1) !then
			add files file= !quote(!concat('C:\temp\',!rwgt,'1.sav')) !do !e=2 !to !modls /file=!quote(!concat('C:\temp\',!rwgt,!e,'.sav')) !doend .
			!let !intgr=!length(!Concat(!blanks(!intgr), !blanks(1))).
			save outfile=!quote(!concat('c:\temp\',!rwgt,'_temp_',!intgr,'.sav')).
		!else
			get file =!quote(!concat('C:\temp\',!rwgt,'1.sav')).
			!let !intgr=!length(!Concat(!blanks(!intgr), !blanks(1))).
			save outfile=!quote(!concat('c:\temp\',!rwgt,'_temp_',!intgr,'.sav')).
		!ifend
	!ifend
	!if ( !length(!substr(!blanks(!intgr),!length(!concat(!blanks(!nper ), !blanks(1)))))=0 ) !then
		add files file= !quote(!concat('C:\temp\',!rwgt,'_temp_1.sav')) !do !e=2 !to !intgr /file=!quote(!concat('C:\temp\',!rwgt,'_temp_',!e,'.sav')) !doend .
	!else
		!let !modls=!intgr.
		!let !intgr1=0.
		!do !iter=!intgr !to !nper !by -!nper
			add files file= !quote(!concat('C:\temp\',!rwgt,'_temp_',!iter,'.sav')) !do !e=!length(!substr(!blanks(!iter),2)) !to !length(!substr(!blanks(!iter),!length(!blanks(!nper)))) !ny -1 /file=!quote(!concat('C:\temp\',!rwgt,'_temp_',!e,'.sav')) !doend.
			!let !modls=!length(!substr(!blanks(!modls),!length(!concat(!blanks(1),!blanks(!nper))))).
			!let !intgr1=!length(!Concat(!blanks(!intgr1), !blanks(1))).
			save outfile=!quote(!concat('c:\temp\',!rwgt,'_tempover_',!intgr1,'.sav')).
		!doend
		!if (!modls>0) !then
			!if (!modls>1) !then
				add files file= !quote(!concat('C:\temp\',!rwgt,'_temp_1.sav')) !do !e=2 !to !modls /file=!quote(!concat('C:\temp\',!rwgt,'_temp_',!e,'.sav')) !doend .
				!let !intgr1=!length(!Concat(!blanks(!intgr1), !blanks(1))).
				save outfile=!quote(!concat('c:\temp\',!rwgt,'_tempover_',!intgr1,'.sav')).
			!else
				get file= !quote(!concat('C:\temp\',!rwgt,'_temp_1.sav')).
				!let !intgr1=!length(!Concat(!blanks(!intgr1), !blanks(1))).
				save outfile=!quote(!concat('c:\temp\',!rwgt,'_tempover_',!intgr1,'.sav')).
			!ifend
		!ifend
		add files file= !quote(!concat('c:\temp\',!rwgt,'_tempover_1.sav')) !do !e=2 !to !intgr1 /file=!quote(!concat('C:\temp\',!rwgt,'_tempover_',!e,'.sav')) !doend .
	!ifend
!ifend
exe.
sort cases by !grp.
save outfile='c:\temp\rep.sav'.

match files /table=!quote(!concat('c:\temp\',!wgt,'.sav')) /file='c:\temp\rep.sav' /by !grp.


*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr.1 to statr.5/
	  b=stat.1 to stat.5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.

aggregate outfile=*/
	  break=!grp /stat.1 to stat.5= mean(stat.1 to stat.5) /var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).


*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat.1 to stat.5).
do repeat a=stat.1 to stat.5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.
compute pvmerr=.25*(sum(pvar1 to pvar5)).


*** COMPUTE SE [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).
formats stat (f8.3)/ SE (f10.6).
exe.
omsend tag="crap".


*** OUTPUT TABLES ***.

oms /select tables /if subtypes='Case Processing Summary' /destination viewer=no /tag="case".
SUMMARIZE
  /TABLES= !if (!nGrp>0) !then !grp !ifend stat SE
  /FORMAT=LIST NOCASENUM
  !if (!ngrp=0) !then /TITLE=!quote(!concat("Relative risk with ",!antecedent,' as antecedent and ',!outcome,' as outcome variables')) 
  !else /TITLE=!quote(!concat("Relative risk with ",!antecedent,' as antecedent and ',!outcome,' as outcome variables by ',!grp)) !ifend
  /CELLS=NONE.

delete variables !if (!ngrp=0) !then !grp !ifend  stat.1 stat.2 stat.3 stat.4 stat.5
   var1 var2 var3 var4 var5 pv_var pvar1 pvar2 pvar3 pvar4 pvar5 pvmerr.
omsend tag="case".
restore.

save outfile="c:\temp\results.sav".


!enddefine.